surfaceScalarField rAUf("rAUf", fvc::interpolate(rAU));

volVectorField HbyA("HbyA", U);
HbyA = rAU*UEqn().H();

if (pimple.nCorrPISO() <= 1)
{
    UEqn.clear();
}

surfaceScalarField phiHbyA
(
    "phiHbyA",
    (fvc::interpolate(HbyA) & mesh.Sf())
  + rAUf*fvc::ddtCorr(U, phi)
);

fvOptions.makeRelative(phiHbyA);

adjustPhi(phiHbyA, U, p);


// Non-orthogonal pressure corrector loop
while (pimple.correctNonOrthogonal())
{
    // Pressure corrector
    fvScalarMatrix pEqn
    (
        fvm::laplacian(rAU, p) == fvc::div(phiHbyA)
    );

    pEqn.setReference(pRefCell, pRefValue);

    pEqn.solve(mesh.solver(p.select(pimple.finalInnerIter())));

    if (pimple.finalNonOrthogonalIter())
    {
        phi = phiHbyA - pEqn.flux();
    }
}

#include "continuityErrs.H"

// Explicitly relax pressure for momentum corrector
p.relax();

U = HbyA - rAU*fvc::grad(p);
U.correctBoundaryConditions();
fvOptions.correct(U);

/*// Extract the velocity in the flow direction
dimensionedScalar magUbarStar =
     (flowDirection & U)().weightedAverage(mesh.V());

   // Calculate the pressure gradient increment needed to
    // adjust the average flow-rate to the correct value
     dimensionedScalar gragPplus =
          (magUbar - magUbarStar)/rAU.weightedAverage(mesh.V());

        U += flowDirection*rAU*gragPplus;

  gradP += gragPplus;

    Info<< "Uncorrected Ubar = " << magUbarStar.value() << tab
         << "pressure gradient = " << gradP.value() << endl;   */


       //  #include "writeGradP.H"
